	#define global EVENT_PRESSED  1
	#define global EVENT_RELEASED 2
	#define global EVENT_ENTERED  3
	#define global EVENT_EXITED   4
	
	#define global OBJECTTEXT_CENTER  1
	#define global OBJECTTEXT_LEFT    2
	#define global OBJECTTEXT_RIGHT   3

#module
	#define inter inter@HspAdv
	#enum OBJECT_BUTTON = 0
	#enum OBJECT_TOGGLE
	#enum OBJECT_IMAGE
	#enum OBJECT_BAR_X
	#enum OBJECT_BAR_Y
	#enum OBJECT_SLIDER_X
	#enum OBJECT_SLIDER_Y
	
#deffunc ObjectModuleInit int _i,int _i2
	KEY_PRESSOBJECT=_i
	DELAY_PRESS=_i2
	dim Materials,5,64
	dim Images,3,256
	dim Objects,10,256
	dim pet,256
	dim _Event,256
	dim Event,256
	sdim Text,256,256
	dim TextFlg,2,256
	dim _font,8
	dim fonts,8,256
	sdim fontface,64,256
	pri=1
	mn=0
	mn2=0
	repeat 256
	Objects(0,cnt)=-1
	loop
return
#defcfunc createMaterial int x1,int y1,int x2,int y2
	Materials(0,mn2)=ginfo(3),x1,y1,x2,y2
	mn2++
return mn2-1
#deffunc addMaterial int index,int index2,int index3
	Images(index2,index)=index3
return
#deffunc setRoomID int _i
	if pri<=0 : return
	pri=_i
return
#deffunc createObject int index,int kof,int imgid,int visibility,int p1,int p2
	Objects(0,index)=pri,kof,ginfo(22),ginfo(23),imgid,0,visibility,p1,p2
	mn++
return
#deffunc setTextFontAndColor int index
	dFont ""+fontface(index),fonts(6,index),fonts(7,index)
	dColor 0,fonts(0,index),fonts(1,index),fonts(2,index)
	dColor 1,fonts(3,index),fonts(4,index),fonts(5,index)
return
#deffunc addText int index,str _s,int _i
	Text(index)=_s
	fontface(index)=getFont(_font)
	repeat 8
	fonts(cnt,index)=_font(cnt)
	loop
	TextFlg(0,index)=1,_i
return
#deffunc setText int index,str _s
	Text(index)=_s
return
#deffunc setMaterial int index,int index2
	Objects(5,index)=index2
return
#defcfunc createButton int mat1,int mat2,int mat3,int visibility
	addMaterial mn,0,mat1
	addMaterial mn,1,mat2
	addMaterial mn,2,mat3
	createObject mn,OBJECT_BUTTON,mn,visibility,0,0
return mn-1
#defcfunc createToggle int mat1,int mat2,int mat3,int visibility,int _i
	addMaterial mn,0,mat1
	addMaterial mn,1,mat2
	addMaterial mn,2,mat3
	createObject mn,OBJECT_TOGGLE,mn,visibility,_i,0
return mn-1
#defcfunc createImage int mat1,int mat2,int mat3,int visibility
	addMaterial mn,0,mat1
	addMaterial mn,1,mat2
	addMaterial mn,2,mat3
	createObject mn,OBJECT_IMAGE,mn,visibility,0,0
return mn-1
#defcfunc createBarX int mat1,int visibility,int _i
	addMaterial mn,0,mat1
	createObject mn,OBJECT_BAR_X,mn,visibility,_i,0
return mn-1
#defcfunc createBarY int mat1,int visibility,int _i
	addMaterial mn,0,mat1
	createObject mn,OBJECT_BAR_Y,mn,visibility,_i,1
return mn-1
#defcfunc createSliderX int mat1,int visibility,int p1,int p2
	addMaterial mn,0,mat1
	createObject mn,OBJECT_SLIDER_X,mn,visibility,p1,p2
return mn-1
#defcfunc createSliderY int mat1,int visibility,int p1,int p2
	addMaterial mn,0,mat1
	createObject mn,OBJECT_SLIDER_Y,mn,visibility,p1,p2
return mn-1
#deffunc changeObject int index
	Objects(0,index)=0-Objects(0,index)
return
#deffunc hideObject int index
	if Objects(0,index)>0 : changeObject index
return
#deffunc appearObject int index
	if Objects(0,index)<0 : changeObject index
return
#deffunc releaseToggle int index
	if Objects(1,index)=OBJECT_TOGGLE : pet(index)=0 : setMaterial index,0 : Event(index)=0 : _Event(index)=Event(index)
return
#deffunc pressToggle int index
	if Objects(1,index)=OBJECT_TOGGLE : pet(index)=DELAY_PRESS : setMaterial index,2 : Event(index)=0 : _Event(index)=Event(index)
return
#deffunc setBarSize int index,int _i
	if (Objects(1,index)=OBJECT_BAR_X) | (Objects(1,index)=OBJECT_BAR_Y) : Objects(7,index)=_i
	if Objects(7,index)<0 : Objects(7,index)=0
return
#deffunc setSliderPos int index,int _i
	if (Objects(1,index)=OBJECT_SLIDER_X) | (Objects(1,index)=OBJECT_SLIDER_Y) : Objects(7,index)=_i
	if Objects(7,index)<0 : Objects(7,index)=0
	if Objects(7,index)>Objects(8,index) : Objects(7,index)=Objects(8,index)
return
#defcfunc getToggle int index
	if pet(index)>0 : return 1
return 0
#defcfunc getEvent int index
return Event(index)
#defcfunc getBarSize int index
	if (Objects(1,index)=OBJECT_BAR_X) | (Objects(1,index)=OBJECT_BAR_Y) : return Objects(7,index)
return -1
#defcfunc getSliderPos int index
	if (Objects(1,index)=OBJECT_SLIDER_X) | (Objects(1,index)=OBJECT_SLIDER_Y) : return Objects(7,index)
return -1
#deffunc drawObject int index
	if index<=0 : return
	ex_pre=0
	stockColor
	getkey2 2,sti,KEY_PRESSOBJECT
	mx=mousex : my=mousey
	repeat 256
	if Objects(0,cnt)!=index : continue
	color 0,255,0
	gmode 4,,,Objects(6,cnt)
	pos Objects(2,cnt),Objects(3,cnt)
	i=Images(Objects(5,cnt),Objects(4,cnt))
	if (Objects(1,cnt)=OBJECT_BAR_X) | (Objects(1,cnt)=OBJECT_BAR_Y) {
		_long=Objects(7,cnt)
		if Objects(8,cnt)=0 {
			if _long>Materials(3,i) : _long=Materials(3,i) : Objects(7,cnt)=_long
			if _long>0 : gcopy Materials(0,i),Materials(1,i),Materials(2,i),_long,Materials(4,i)
		} else {
			if _long>Materials(4,i) : _long=Materials(4,i) : Objects(7,cnt)=_long
			if _long>0 : gcopy Materials(0,i),Materials(1,i),Materials(2,i),Materials(3,i),_long
		}
	} else {
		if Objects(1,cnt)=OBJECT_SLIDER_X : pos Objects(2,cnt)+Objects(7,cnt),Objects(3,cnt)
		if Objects(1,cnt)=OBJECT_SLIDER_Y : pos Objects(2,cnt),Objects(3,cnt)+Objects(7,cnt)
		gcopy Materials(0,i),Materials(1,i),Materials(2,i),Materials(3,i),Materials(4,i)
	}
	px=Objects(2,cnt)
	py=Objects(3,cnt)
	sx=Materials(3,i)
	sy=Materials(4,i)
	if TextFlg(0,cnt)=1 {
	stockStyle
	setTextFontAndColor cnt
	if TextFlg(1,cnt)=OBJECTTEXT_CENTER : tpx=px+(sx-strlen(Text(cnt))*getdFontSize()/2)/2
	if TextFlg(1,cnt)=OBJECTTEXT_LEFT   : tpx=px
	if TextFlg(1,cnt)=OBJECTTEXT_RIGHT  : tpx=px+sx-strlen(Text(cnt))*getdFontSize()/2
	tpy=py+(sy-getdFontSize())/2
	pos tpx,tpy
	dMes Text(cnt)
	setStockedStyle
	}
	zx=px+sx : zy=py+sy

	Event(cnt)=0
	if Objects(1,cnt)=OBJECT_BUTTON {
		if pet(cnt)>0 : pet(cnt)-- : continue
		if (px<=mx) & (mx<=zx) & (py<=my) & (my<=zy) {
			setMaterial cnt,1
			if _Event(cnt)!=EVENT_ENTERED : Event(cnt)=EVENT_ENTERED : _Event(cnt)=Event(cnt)
			if KEY_PRESSOBJECT&sti {
				Event(cnt)=EVENT_PRESSED : setMaterial cnt,2 : _Event(cnt)=Event(cnt)
				ex_pre=1
			} else {
				if KEY_PRESSOBJECT&_sti : pet(cnt)=DELAY_PRESS : Event(cnt)=EVENT_RELEASED : setMaterial cnt,2 : _Event(cnt)=Event(cnt)
			}
		} else {
			setMaterial cnt,0
			if _Event(cnt)!=EVENT_EXITED : Event(cnt)=EVENT_EXITED : _Event(cnt)=Event(cnt)
		}
	}
	if Objects(1,cnt)=OBJECT_TOGGLE {
		if (px<=mx) & (mx<=zx) & (py<=my) & (my<=zy) {
			if pet(cnt)=0 {
			setMaterial cnt,1
			if _Event(cnt)!=EVENT_ENTERED : Event(cnt)=EVENT_ENTERED : _Event(cnt)=Event(cnt)
			}
			if KEY_PRESSOBJECT&sti {
				Event(cnt)=EVENT_PRESSED : setMaterial cnt,2 : _Event(cnt)=Event(cnt)
				ex_pre=1
			} else {
				if KEY_PRESSOBJECT&_sti {
					if pet(cnt)=0 : pet(cnt)=DELAY_PRESS : else : if Objects(7,cnt)=0 : pet(cnt)=0
					Event(cnt)=EVENT_RELEASED : setMaterial cnt,2 : _Event(cnt)=Event(cnt)
				}
			}
		} else {
			if pet(cnt)>0 : continue
			setMaterial cnt,0
			if _Event(cnt)!=EVENT_EXITED : Event(cnt)=EVENT_EXITED : _Event(cnt)=Event(cnt)
		}
	}
	if Objects(1,cnt)=OBJECT_SLIDER_X {
		_px=px
		_sx=sx/2
		px+=Objects(7,cnt)
		zx+=Objects(7,cnt)
		if (px<=mx) & (mx<=zx) & (py<=my) & (my<=zy) {
			if _Event(cnt)!=EVENT_ENTERED : Event(cnt)=EVENT_ENTERED : _Event(cnt)=Event(cnt)
			if KEY_PRESSOBJECT&sti {
				setSliderPos cnt,mx-_px-_sx
				Event(cnt)=EVENT_PRESSED : _Event(cnt)=Event(cnt)
				ex_pre=1
			} else {
				if KEY_PRESSOBJECT&_sti : Event(cnt)=EVENT_RELEASED : _Event(cnt)=Event(cnt)
			}
		} else {
			if _Event(cnt)=EVENT_PRESSED {
				if KEY_PRESSOBJECT&sti : if (py<=my) & (my<=zy) : setSliderPos cnt,mx-_px-_sx : else : Event(cnt)=EVENT_EXITED : _Event(cnt)=Event(cnt)
			} else {
				if _Event(cnt)!=EVENT_EXITED : Event(cnt)=EVENT_EXITED : _Event(cnt)=Event(cnt)
			}
		}
	}
	if Objects(1,cnt)=OBJECT_SLIDER_Y {
		_py=py
		_sy=sy/2
		py+=Objects(7,cnt)
		zy+=Objects(7,cnt)
		if (px<=mx) & (mx<=zx) & (py<=my) & (my<=zy) {
			if _Event(cnt)!=EVENT_ENTERED : Event(cnt)=EVENT_ENTERED : _Event(cnt)=Event(cnt)
			if KEY_PRESSOBJECT&sti {
				setSliderPos cnt,my-_py-_sy
				Event(cnt)=EVENT_PRESSED : _Event(cnt)=Event(cnt)
				ex_pre=1
			} else {
				if KEY_PRESSOBJECT&_sti : Event(cnt)=EVENT_RELEASED : _Event(cnt)=Event(cnt)
			}
		} else {
			if _Event(cnt)=EVENT_PRESSED {
				if KEY_PRESSOBJECT&sti : if (px<=mx) & (mx<=zx) : setSliderPos cnt,my-_py-_sy : else : Event(cnt)=EVENT_EXITED : _Event(cnt)=Event(cnt)
			} else {
				if _Event(cnt)!=EVENT_EXITED : Event(cnt)=EVENT_EXITED : _Event(cnt)=Event(cnt)
			}
		}
	}
	loop
	_sti=sti
	setStockedColor
return
#defcfunc existPressedObject
return ex_pre
#global